# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class ArmBrokerageApiCoreV1alpha1ServerCredential(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, server: str=None, token: str=None, certificate_authority: str=None, username: str=None, password: str=None):  # noqa: E501
        """ArmBrokerageApiCoreV1alpha1ServerCredential - a model defined in Swagger

        :param server: The server of this ArmBrokerageApiCoreV1alpha1ServerCredential.  # noqa: E501
        :type server: str
        :param token: The token of this ArmBrokerageApiCoreV1alpha1ServerCredential.  # noqa: E501
        :type token: str
        :param certificate_authority: The certificate_authority of this ArmBrokerageApiCoreV1alpha1ServerCredential.  # noqa: E501
        :type certificate_authority: str
        :param username: The username of this ArmBrokerageApiCoreV1alpha1ServerCredential.  # noqa: E501
        :type username: str
        :param password: The password of this ArmBrokerageApiCoreV1alpha1ServerCredential.  # noqa: E501
        :type password: str
        """
        self.swagger_types = {
            'server': str,
            'token': str,
            'certificate_authority': str,
            'username': str,
            'password': str
        }

        self.attribute_map = {
            'server': 'server',
            'token': 'token',
            'certificate_authority': 'certificateAuthority',
            'username': 'username',
            'password': 'password'
        }
        self._server = server
        self._token = token
        self._certificate_authority = certificate_authority
        self._username = username
        self._password = password


    @classmethod
    def from_dict(cls, dikt) -> 'ArmBrokerageApiCoreV1alpha1ServerCredential':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The armBrokerage.api.core.v1alpha1.ServerCredential of this ArmBrokerageApiCoreV1alpha1ServerCredential.  # noqa: E501
        :rtype: ArmBrokerageApiCoreV1alpha1ServerCredential
        """
        credModel = util.deserialize_model(dikt, cls)

        print("Credential received:",credModel)

        if not credModel.certificate_authority is None and (credModel.username is None or credModel.password is None):
            raise ValueError("Invalid value for `credential`, certificateAuthority has to also have username and password")  # noqa: E501

        if credModel.token is None and credModel.certificate_authority is None:
            raise ValueError("Invalid value for `credential`, token or certificateAuthority cannot be `None` at the same time")  # noqa: E501

        return credModel

    @property
    def server(self) -> str:
        """Gets the server of this ArmBrokerageApiCoreV1alpha1ServerCredential.

        Server access point. Ex: https://192.168.0.1:6443.  # noqa: E501

        :return: The server of this ArmBrokerageApiCoreV1alpha1ServerCredential.
        :rtype: str
        """
        return self._server

    @server.setter
    def server(self, server: str):
        """Sets the server of this ArmBrokerageApiCoreV1alpha1ServerCredential.

        Server access point. Ex: https://192.168.0.1:6443.  # noqa: E501

        :param server: The server of this ArmBrokerageApiCoreV1alpha1ServerCredential.
        :type server: str
        """
        if server is None:
            raise ValueError("Invalid value for `server`, must not be `None`")  # noqa: E501

        self._server = server

    @property
    def token(self) -> str:
        """Gets the token of this ArmBrokerageApiCoreV1alpha1ServerCredential.

        k3s token.  # noqa: E501

        :return: The token of this ArmBrokerageApiCoreV1alpha1ServerCredential.
        :rtype: str
        """
        return self._token

    @token.setter
    def token(self, token: str):
        """Sets the token of this ArmBrokerageApiCoreV1alpha1ServerCredential.

        k3s token.  # noqa: E501

        :param token: The token of this ArmBrokerageApiCoreV1alpha1ServerCredential.
        :type token: str
        """

        self._token = token

    @property
    def certificate_authority(self) -> str:
        """Gets the certificate_authority of this ArmBrokerageApiCoreV1alpha1ServerCredential.

        k3s token.  # noqa: E501

        :return: The certificate_authority of this ArmBrokerageApiCoreV1alpha1ServerCredential.
        :rtype: str
        """
        return self._certificate_authority

    @certificate_authority.setter
    def certificate_authority(self, certificate_authority: str):
        """Sets the certificate_authority of this ArmBrokerageApiCoreV1alpha1ServerCredential.

        k3s token.  # noqa: E501

        :param certificate_authority: The certificate_authority of this ArmBrokerageApiCoreV1alpha1ServerCredential.
        :type certificate_authority: str
        """

        self._certificate_authority = certificate_authority

    @property
    def username(self) -> str:
        """Gets the username of this ArmBrokerageApiCoreV1alpha1ServerCredential.

        k3s username.  # noqa: E501

        :return: The username of this ArmBrokerageApiCoreV1alpha1ServerCredential.
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username: str):
        """Sets the username of this ArmBrokerageApiCoreV1alpha1ServerCredential.

        k3s username.  # noqa: E501

        :param username: The username of this ArmBrokerageApiCoreV1alpha1ServerCredential.
        :type username: str
        """

        self._username = username

    @property
    def password(self) -> str:
        """Gets the password of this ArmBrokerageApiCoreV1alpha1ServerCredential.

        k3s password.  # noqa: E501

        :return: The password of this ArmBrokerageApiCoreV1alpha1ServerCredential.
        :rtype: str
        """
        return self._password

    @password.setter
    def password(self, password: str):
        """Sets the password of this ArmBrokerageApiCoreV1alpha1ServerCredential.

        k3s password.  # noqa: E501

        :param password: The password of this ArmBrokerageApiCoreV1alpha1ServerCredential.
        :type password: str
        """

        self._password = password
